/************************* MPEG-2 NBC Audio Decoder **************************
 *                                                                           *
"This software module was originally developed by 
AT&T, Dolby Laboratories, Fraunhofer Gesellschaft IIS 
and edited by
Yoshiaki Oikawa (Sony Corporation),
Mitsuyuki Hatanaka (Sony Corporation)
in the course of development of the MPEG-2 NBC/MPEG-4 Audio standard ISO/IEC 13818-7, 
14496-1,2 and 3. This software module is an implementation of a part of one or more 
MPEG-2 NBC/MPEG-4 Audio tools as specified by the MPEG-2 NBC/MPEG-4 
Audio standard. ISO/IEC  gives users of the MPEG-2 NBC/MPEG-4 Audio 
standards free license to this software module or modifications thereof for use in 
hardware or software products claiming conformance to the MPEG-2 NBC/MPEG-4
Audio  standards. Those intending to use this software module in hardware or 
software products are advised that this use may infringe existing patents. 
The original developer of this software module and his/her company, the subsequent 
editors and their companies, and ISO/IEC have no liability for use of this software 
module or modifications thereof in an implementation. Copyright is not released for 
non MPEG-2 NBC/MPEG-4 Audio conforming products.The original developer
retains full right to use the code for his/her  own purpose, assign or donate the 
code to a third party and to inhibit third party from using the code for non 
MPEG-2 NBC/MPEG-4 Audio conforming products. This copyright notice must
be included in all copies or derivative works." 
Copyright(c)1996.
 *                                                                           *
 ****************************************************************************/

#include "all.h"
#include "port.h"

#if USELIB_ISOMP4
#include "MP4Movies.h"
void            init_mp4file(MP4Track* trak, MP4Handle* decoderSpecificInfoH);
#endif


int
main(int argc, char *argv[])
{

#if USELIB_ISOMP4
  MP4Err err;
  MP4Handle sampleH;
  MP4Handle decoderSpecificInfoH; 
  MP4Track trak;
  MP4TrackReader reader;

  u32 unitSize, sampleFlags, cts, dts;
#endif
  int remainingArgs;
  long fileNumSample;

  remainingArgs = initio(argc, argv, &fileNumSample);	    /* parse command line */

  init_dec();

#if USELIB_ISOMP4

  if ( mpeg4_header_present == 1 ) {
    init_mp4file(&trak, &decoderSpecificInfoH);
    restartio(*decoderSpecificInfoH);
  } else {
    decoderSpecificInfoH = NULL;
    restartio(NULL);
  }

  if ( mpeg4_header_present == 1 ) {
    init_config((remainingArgs == 1));  /* read (and possibly print) decoderSpecificInfo */

    if ((err = MP4CreateTrackReader( trak, &reader ))) myexit("mp4lib-trackReader");
    if ((err = MP4NewHandle( 0, &sampleH ))) myexit("mp4lib");

  }
#else

  restartio();	    /* reset io counters */

#endif

  if (adif_header_present == 1) {
    if (!get_adif_header((remainingArgs == 1)))     /* read (and possibly print) adif header */
      myexit(0);
    byte_align();
  }   

#ifdef ADTS
  if(adts_header_present != 1){
    init();        /* initialize data structures */
  }
#else
  init();		    /* initialize data structures */
#endif


  /* main loop */    
  for(bno = 0; ; bno++) {
    
#if USELIB_ISOMP4
    if ( mpeg4_header_present == 1 ) {
      if (( err = MP4TrackReaderGetNextAccessUnit( reader, sampleH, &unitSize, &sampleFlags, &cts, &dts ))) {
	if (err == MP4EOF) myexit("finished");
	else myexit("mp4lib-GetTrackUnit");
      }
      restartio(*sampleH);
    }
#endif

    dec(bno);

  }
  

}
