#! /usr/bin/tcsh -f
# strip-to-mpeg2.sh
#
# remove any source code thats not really part of MPEG-2 AAC Reference Software ..
#
# Ralph Sperschneider, Fraunhofer Institute for Integrated Circuits
# Heiko Purnhagen, Coding Technologies
# RS 20010328
# RB 20020711
# RS 20021027
# RS 20041221
# HP 2005-02-03  ported to conf_sbr
#
# usage:
#   ./strip-to-mpeg2.sh
#

mv src src_mpeg4
mv makefile makefile.mpeg4
mkdir src

cd src_mpeg4
foreach i ( *.[ch] )
    echo "stripping [key=MPEG4V1] $i";
    ../../general/strip_ifdef key=MPEG4V1 $i >! ../src/$i
end
cd ..

echo processing makefile
../general/strip_ifdef key=MPEG4V1 makefile.mpeg4 >! makefile

rm -r src_mpeg4 makefile.mpeg4

####
