#! /usr/bin/tcsh -f
# strip-to-mpeg2.sh
#
# remove any source code thats not really part of MPEG-2 AAC Reference Software ..
#
# Ralph Sperschneider, Fraunhofer Institute for Integrated Circuits
# RS 20010328
# RS 20020711
# RS 20021027
# RS 20041221
# RS 20050128 - disabled CT_SBR strip
#
# usage:
#   ./strip-to-mpeg2.sh
#
mv src src_mpeg4
mv makefile makefile.mpeg4
mkdir -p src #src_tmp

cd src_mpeg4
foreach i ( *.[ch] )
    echo "stripping [key=MPEG4V1] $i";
    ../../general/strip_ifdef key=MPEG4V1 $i >! ../src/$i
#    ../../general/strip_ifdef key=MPEG4V1 $i >! ../src_tmp/$i
end
#cd ../src_tmp
#foreach i ( *.[ch] )
#    echo "stripping [key=CT_SBR] $i";
#    ../../general/strip_ifdef key=CT_SBR $i >! ../src/$i
#end
cd ../src
foreach i ( nok_ltp_common.h nok_ltp_common_internal.h nok_ltp_enc.c nok_ltp_enc.h nok_pitch.c nok_pitch.h )
    echo removing obsolete file $i;
    rm $i
end
cd ..

echo processing makefile
../general/strip_ifdef key=MPEG4V1 makefile.mpeg4 >! makefile #.tmp
#../general/strip_ifdef key=CT_SBR makefile.tmp >! makefile

rm -r src_mpeg4 makefile.mpeg4 #src_tmp makefile.tmp
