#!/usr/local/bin/perl
#
# usage:
#     get_profile_level.pl <bitstream.mp4>
#
# script to analyze output of RefSoft (rewrite) and calculate minimum
# profile&level necessary for decoding this bitstream
# (probably has bugs)

$INFILE=$ARGV[0];
#$DECODER="/home/mpaudcon/user/kaehleof/rewrite/bin/mp4AudVm_Tbt_VmMp4AuDecRewrite/Linux_v2_c1_g++_O3/mp4audec -d 2 -o /tmp/out.wav";
$DECODER="../bin/mp4AudVm_Tbt_VmMp4AuDecRewrite/Linux_v2_c1_eptool_sbr_gcc_O3/mp4audec -d 8 -daac vVh -o out.wav";

@full_profile_list=(Speech,Synthetic,Scalable,Main,HighQuality,LowDelay,Natural,MobileInternet);
### table of profiles for AOTs (ISO/IEC 14496-3:2001, 1.5.2, table 1.2)
@{$profiles_for{'AM'   }}=(Main, Natural);
@{$profiles_for{'AL'   }}=(Scalable,Main,HighQuality,Natural);
@{$profiles_for{'AS'   }}=(Main,Natural);
@{$profiles_for{'AP'   }}=(Scalable,Main,HighQuality,Natural);
@{$profiles_for{'AC'   }}=(Scalable,Main,HighQuality,Natural);
@{$profiles_for{'TV'   }}=(Scalable,Main,Natural);
@{$profiles_for{'CE'   }}=(Speech,Scalable,Main,HighQuality,LowDelay,Natural);
@{$profiles_for{'HV'   }}=(Speech,Scalable,Main,LowDelay,Natural);
@{$profiles_for{'TT'   }}=(Speech,Synthetic,Scalable,Main,LowDelay,Natural);
@{$profiles_for{'MS'   }}=(Synthetic,Main);
@{$profiles_for{'ER_AL'}}=(HighQuality,Natural,MobileInternet);
@{$profiles_for{'ER_AP'}}=(HighQuality,Natural);
@{$profiles_for{'ER_AC'}}=(HighQuality,Natural,MobileInternet);
@{$profiles_for{'ER_TV'}}=(Natural,MobileInternet);
@{$profiles_for{'ER_BS'}}=(Natural,MobileInternet);
@{$profiles_for{'ER_AD'}}=(LowDelay,Natural,MobileInternet);
@{$profiles_for{'ER_CE'}}=(HighQuality,LowDelay,Natural);
@{$profiles_for{'ER_HV'}}=(LowDelay,Natural);
@{$profiles_for{'ER_HI'}}=(Natural);
@{$profiles_for{'ER_PA'}}=(Natural);

#format: fs_ref, pcu_ref, rcu_ref, proportional_to_samplingrate
@{$refdat_for{'AM'   }} = ( (48000,5,5,1) );
@{$refdat_for{'AL'   }} = ( (48000,3,3,1) );
@{$refdat_for{'AS'   }} = ( (48000,4,3,1) );
@{$refdat_for{'AP'   }} = ( (48000,4,4,1) );
@{$refdat_for{'AC'   }} = ( (48000,5,4,1) );
@{$refdat_for{'TV'   }} = ( (24000,2,3,1) );
@{$refdat_for{'CE'   }} = ( ( 8000,1,1,0), (16000,2,1,0), (0,3,1,0) );
@{$refdat_for{'HV'   }} = ( ( 8000,2,1,0) );
###ttsi,wavetable,mainsynth,algorithmic???
@{$refdat_for{'ER_AL'}} = ( (48000,3,3,1) );
@{$refdat_for{'ER_AP'}} = ( (48000,4,4,1) );
@{$refdat_for{'ER_AC'}} = ( (48000,5,4,1) );
@{$refdat_for{'ER_TV'}} = ( (24000,2,3,1) );
###ER_BSAC???
@{$refdat_for{'ER_AD'}} = ( (48000,3,2,1) );
@{$refdat_for{'ER_CE'}} = ( ( 8000,2,1,0), (16000,3,1,0) );
@{$refdat_for{'ER_HV'}} = ( ( 8000,2,1,0) );
###ER-HILN? ER-PARA?


#@alist=(1,2,3);
#@blist=(a,b,\@alist);
#for my $xtmp (@blist) {print $xtmp."\n";}
#for my $xtmp (@{$blist[2]}) {print $xtmp."\n";}
#exit;

#take $1:AOT; $2:Samplingrate; $3..$7:SCE,CPE,LFE,DCC,ICC, @$8:extra
sub get_PCU {
  my @args=@_;
  my @tmplist=@{$refdat_for{@args[0]}};
  my $fs_ref=0;
  my $pcu_ref=0;
  my $rcu_ref=0;
  my $prop_to_smpl_rate=0;
  my $tmp2=$args[1];
  if (@args[0]=~ 'CE') {if (grep (/bandwidthscal./,@{$args[7]})) {$tmp2=0;}}
  while (@tmplist) {
    ($fs_ref,$pcu_ref,$rcu_ref,$prop_to_smpl_rate,@tmplist)=@tmplist;
    if (($prop_to_smpl_rate)||($fs_ref==$tmp2)) {last;}
  }
  if (!$prop_to_smpl_rate) {return $pcu_ref;}
  shift;
  return (((shift) / $fs_ref) * $pcu_ref * ((shift) + 2*(shift) + (shift) + 0.3*(shift) + (shift)));
}

sub get_RCU {
  my @args=@_;
  my @tmplist=@{$refdat_for{@args[0]}};
  my $fs_ref=0;
  my $pcu_ref=0;
  my $rcu_ref=0;
  my $prop_to_smpl_rate=0;
  my $tmp2=$args[1];
  if (@args[0]=~ 'CE') {if (grep (/bandwidthscal./,@{$args[7]})) {$tmp2=0;}}
  while (@tmplist) {
    ($fs_ref,$pcu_ref,$rcu_ref,$prop_to_smpl_rate,@tmplist)=@tmplist;
    if (($prop_to_smpl_rate)||($fs_ref==$tmp2)) {last;}
  }
  if (!$prop_to_smpl_rate) {return $rcu_ref;}
  shift;shift;
  my $tmp3=shift;
  my $tmp4=shift;
  if ($tmp4<2) {
    return ($rcu_ref * ( $tmp3 + 0.5*(shift) + 0.4*(shift) + 0.5*(shift)) + ( $rcu_ref*2-1 )*$tmp4 );
  } else {
    return ($rcu_ref * ( $tmp3 + 0.5*(shift) + 0.4*(shift) + 0.5*(shift)) + $rcu_ref + ($rcu_ref-1)*(2*$tmp4 -1) );
  }
}

#All take $1:AOT; $2:Samplingrate; $3..$7:SCE,CPE,LFE,DCC,ICC; @$8:ExtraInfos
$test_profile{"Speech"} = sub {
  print "not working: testing level for Speech-Profile\n";
  return ();
};

$test_profile{"Synthetic"} = sub {
  print "not working: testing level for Synthetic-Profile\n";
  return ();
};

$test_profile{"Scalable"} = sub {
#testing level for Scalable-Profile
  $test_pcu=get_PCU(@_);
  $test_rcu=get_RCU(@_);
  my $test_aot=shift;
  my $test_smp=shift;
  my $chn_sce=shift;
  my $chn_cpe=shift;
  my $chn_lfe=shift;
  my $chn_dcc=shift;
  my $chn_icc=shift;
  my $mono_obj=$chn_sce+$chn_lfe;
  my $cpl_obj=$chn_dcc+$chn_icc;
  local @level_list=();
  if (($mono_obj<=1)&&($chn_cpe==0)&&($cpl_obj==0)&&($test_smp<=24000)) { @level_list=(@level_list,1);}
  if (($mono_obj+2*$chn_cpe<=2)&&($cpl_obj==0)&&($test_smp<=24000)) { @level_list=(@level_list,2);}
  if (($mono_obj+2*$chn_cpe<=2)&&($cpl_obj==0)&&($test_smp<=48000)) { @level_list=(@level_list,3);}
  if (($test_pcu<30)&&($test_rcu<19)&&($test_smp<=48000)) { @level_list=(@level_list,4);}
  #missing for level 4: "multiple objects with at maximum one integer factor samplingrate conversion for a maximum of 2 channels"
  return @level_list;
};

$test_profile{"Main"} = sub {
#testing level for Main-Profile
  local @level_list=();
  my @test_nat_level=&{$test_profile{"Natural"}}(@_);
  $test_pcu=get_PCU(@_);
  $test_rcu=get_RCU(@_);
  if ((grep /1/,@test_nat_level)&&($PCU<40)&&(RCU<20)) {@level_list=(@level_list,1);}
  if ((grep /2/,@test_nat_level)&&($PCU<80)&&(RCU<64)) {@level_list=(@level_list,2);}
  if ((grep /3/,@test_nat_level)&&($PCU<160)&&(RCU<128)) {@level_list=(@level_list,3);}
  if ((grep /4/,@test_nat_level)&&($PCU<320)&&(RCU<256)) {@level_list=(@level_list,4);}
  return @level_list;
};

$test_profile{"HighQuality"} = sub {
#testing level for HighQuality-Profile
  local @level_list=();
  $test_pcu=get_PCU(@_);
  $test_rcu=get_RCU(@_);
  my $test_aot=shift;
  my $test_smp=shift;
  my $chn_sce=shift;
  my $chn_cpe=shift;
  my $chn_lfe=shift;
  my $channels=$chn_sce+2*$chn_cpe+$chn_lfe;
  if (($channels<=2)&&($test_smp<=22050)&&($test_pcu<=5)&&($test_rcu<=8)) {@level_list=(@level_list,1);}
  if (($channels<=2)&&($test_smp<=48000)&&($test_pcu<=10)&&($test_rcu<=8)) {@level_list=(@level_list,2);}
  if (($channels<=6)&&($chn_lfe<=1)&&($test_smp<=48000)&&($test_pcu<=25)&&($test_rcu<=12)) {@level_list=(@level_list,3);}
  if (($channels<=6)&&($chn_lfe<=1)&&($test_smp<=48000)&&($test_pcu<=100)&&($test_rcu<=42)) {@level_list=(@level_list,4);}
#missing: ep-stuff for level>4
  if (($channels<=2)&&($test_smp<=22050)&&($test_pcu<=5)&&($test_rcu<=8)) {@level_list=(@level_list,5);}
  if (($channels<=2)&&($test_smp<=48000)&&($test_pcu<=10)&&($test_rcu<=8)) {@level_list=(@level_list,6);}
  if (($channels<=6)&&($chn_lfe<=1)&&($test_smp<=48000)&&($test_pcu<=25)&&($test_rcu<=12)) {@level_list=(@level_list,7);}
  if (($channels<=6)&&($chn_lfe<=1)&&($test_smp<=48000)&&($test_pcu<=100)&&($test_rcu<=42)) {@level_list=(@level_list,8);}
  return @level_list;
};

$test_profile{"LowDelay"} = sub {
#testing level for LowDelay-Profile
  local @level_list=();
  $test_pcu=get_PCU(@_);
  $test_rcu=get_RCU(@_);
  my $test_aot=shift;
  my $test_smp=shift;
  my $chn_sce=shift;
  my $chn_cpe=shift;
  my $chn_lfe=shift;
  if ($chn_lfe) {return @level_list;}
  my $channels=$chn_sce+2*$chn_cpe;
  if (($channels<=1)&&($test_smp<=8000)&&($test_pcu<=2)&&($test_rcu<=1)) {@level_list=(@level_list,1);}
  if (($channels<=1)&&($test_smp<=16000)&&($test_pcu<=3)&&($test_rcu<=1)) {@level_list=(@level_list,2);}
  if (($channels<=1)&&($test_smp<=48000)&&($test_pcu<=3)&&($test_rcu<=2)) {@level_list=(@level_list,3);}
  if (($channels<=2)&&($test_smp<=48000)&&($test_pcu<=24)&&($test_rcu<=12)) {@level_list=(@level_list,4);}
#missing: ep-stuff for level>4
  if (($channels<=1)&&($test_smp<=8000)&&($test_pcu<=2)&&($test_rcu<=1)) {@level_list=(@level_list,5);}
  if (($channels<=1)&&($test_smp<=16000)&&($test_pcu<=3)&&($test_rcu<=1)) {@level_list=(@level_list,6);}
  if (($channels<=1)&&($test_smp<=48000)&&($test_pcu<=3)&&($test_rcu<=2)) {@level_list=(@level_list,7);}
  if (($channels<=2)&&($test_smp<=48000)&&($test_pcu<=24)&&($test_rcu<=12)) {@level_list=(@level_list,8);}
  return @level_list;
};

$test_profile{"Natural"} = sub {
# testing level for Natural-Profile
  $test_pcu=get_PCU(@_);
  $test_rcu=get_RCU(@_);
  my $test_aot=shift;
  my $test_smp=shift;
  local @level_list=();
  if (($test_smp<=48000)&&($test_pcu<=20)) {@level_list=(@level_list,1);}
  if (($test_smp<=96000)&&($test_pcu<=100)) {@level_list=(@level_list,2);}
  if (($test_smp<=48000)&&($test_pcu<=20)) {@level_list=(@level_list,3);} #missing EP-stuff
  if (($test_smp<=96000)&&($test_pcu<=100)) {@level_list=(@level_list,4);} #missing EP-stuff
  return @level_list;
};

$test_profile{"MobileInternet"} = sub {
#testing level for MobileInternet-Profile
  local @level_list=();
  $test_pcu=get_PCU(@_);
  $test_rcu=get_RCU(@_);
  my $test_aot=shift;
  my $test_smp=shift;
  my $chn_sce=shift;
  my $chn_cpe=shift;
  my $chn_lfe=shift;
  my $channels=$chn_sce+2*$chn_cpe+$chn_lfe;
#missing: num_aots (fixed)
  if ((@ao_list<=1)&&($channels<=1)&&($test_smp<=24000)&&($test_pcu<=2.5)&&($test_rcu<=4)) {@level_list=(@level_list,1);}
  if ((@ao_list<=2)&&($channels<=2)&&($test_smp<=48000)&&($test_pcu<=10)&&($test_rcu<=8)) {@level_list=(@level_list,2);}
  if (($channels<=6)&&($chn_lfe<=1)&&($test_smp<=48000)&&($test_pcu<=25)&&($test_rcu<=12)) {@level_list=(@level_list,3);}
#missing: ep-stuff for level>3
  if ((@ao_list<=1)&&($channels<=1)&&($test_smp<=24000)&&($test_pcu<=2.5)&&($test_rcu<=4)) {@level_list=(@level_list,4);}
  if ((@ao_list<=2)&&($channels<=2)&&($test_smp<=48000)&&($test_pcu<=10)&&($test_rcu<=8)) {@level_list=(@level_list,5);}
  if (($channels<=6)&&($chn_lfe<=1)&&($test_smp<=48000)&&($test_pcu<=25)&&($test_rcu<=12)) {@level_list=(@level_list,6);}
  return @level_list;
};


#@item=('AM',24000,1,1,1,0,0);
#
#for $x (&{$test_profile{'MobileInternet'}}(@item)) {print "level $x\n";}
#$x=get_PCU(@item);
#$y=get_RCU(@item);
#print "PCU $x  RCU $y\n";
#exit;

#@a=(1,2,3,4);
#@b=(1,2);
#@c=();
#for $x (@a) {if (! grep(/$x/,@b)) {print $x."\n";}}
#for $x (@b) {@c=(@c,grep(/$x/,@a));}
#for $x (@c) {print $x;}
#exit;




sub translate_AOT {
  $x=shift;
  $x=~s/.*Error Resilient /ER_/i;
  $x=~s/AAC Main.*/AM/i;
  $x=~s/AAC Low Complexity.*/AL/i;
  $x=~s/AAC Scalable Sampling Rate.*/AS/i;
  $x=~s/AAC Long Term Predict.*/AP/i;
  $x=~s/AAC Scalable.*/AC/i;
  $x=~s/TwinVQ.*/TV/i;
  $x=~s/CELP.*/CE/i;
  $x=~s/HVXC.*/HV/i;
  $x=~s/BSAC.*/BS/i;
  $x=~s/AAC LD.*/AD/i;
  $x=~s/HILN.*/HI/i;
  $x=~s/Para.*/PA/i;
  return $x;
}

$cur_ao=0;
@ao_list=(0);

for $x ( `$DECODER $INFILE 2>&1` ) {
  if ( $x =~ /ES.*Layer.*: *(\d*)/i ) {
    $cur_ao=$1;
    if (!(grep /$cur_ao/,@ao_list)) {@ao_list=(@ao_list, $cur_ao); }
    $config_chn_sce[$cur_ao]=0;
    $config_chn_cpe[$cur_ao]=0;
    $config_chn_lfe[$cur_ao]=0;
    $config_chn_dcc[$cur_ao]=0;
    $config_chn_icc[$cur_ao]=0;
    @config_extra[$cur_ao]=();
  }
  if ( $x =~ /b(and)?w(idth)?.*S(calab)?[^123456789]*/i ) { @{$config_extra[$cur_ao]}=(@{$config_extra[$cur_ao]},"bandwidthscal."); }
  if ( $x =~ /audio.*Obj.*Type.*: *(.*)/i ) {
    $config_aot[$cur_ao]=translate_AOT($1);
  }
  if ( $x =~ /chan.*Conf.*: *(.*)/i ) {
    $y=$1;
    if ($y==1) { $config_chn_sce[$cur_ao]=1; }
    elsif ($y==2) { $config_chn_cpe[$cur_ao]=1; }
    elsif ($y==3) { $config_chn_sce[$cur_ao]=1;
                    $config_chn_cpe[$cur_ao]=1; }
    elsif ($y==4) { $config_chn_sce[$cur_ao]=2;
                    $config_chn_cpe[$cur_ao]=1; }
    elsif ($y==5) { $config_chn_sce[$cur_ao]=1;
                    $config_chn_cpe[$cur_ao]=2; }
    elsif ($y==6) { $config_chn_sce[$cur_ao]=1;
                    $config_chn_cpe[$cur_ao]=2;
                    $config_chn_lfe[$cur_ao]=1; }
    elsif ($y==7) { $config_chn_sce[$cur_ao]=1;
                    $config_chn_cpe[$cur_ao]=3;
                    $config_chn_lfe[$cur_ao]=1; }
    else {print "unknown channel config... sorry!";}
  }
  if ( $x =~ /sampl.*Freq *: *(.*)/i ) {
    $config_smp[$cur_ao]=$1;
  }
}

$init=0;
for my $x ( @ao_list ) {
#  print "AudioObject:$x\n";
#  print "AOT:$config_aot[$x]\n";
#  print "smp:$config_smp[$x]\n";
  for my $y (@{$profiles_for{$config_aot[$x]}}) {
    @ll=&{$test_profile{$y}} ( $config_aot[$x], $config_smp[$x], $config_chn_sce[$x], $config_chn_cpe[$x], $config_chn_lfe[$x], $config_chn_dcc[$x], $config_chn_icc[$x], \@{$config_extra[$x]} );

#    if (@ll) {print "$y Audio Profile:\n";}
#    for my $l (@ll) {print "level $l\n";}

    if ($init==0) { @{$levels{$y}} = @ll; }
    else { @tmp=();
           for my $z (@{$levels{$y}}) {@tmp=(@tmp,grep(/$z/,@ll));}
           @{$levels{$y}} = @tmp;
         }
  }
  for my $y (@full_profile_list) {if (!grep(/$y/,@{$profiles_for{$config_aot[$x]}})) {@{$levels{$y}}=();}}
  $init=1;
}

print "--------------------\nsummary:\n";
for my $y (@full_profile_list) {
  if (@{$levels{$y}}) {print "$y Audio Profile:\n";}
  for my $l (@{$levels{$y}}) {print "level $l\n";}
}
